<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  CTA as CallToAction,
  FeaturedMedia,
  CopyMedia,
  Copy,
} from '../../components/common/index';
import {
  SdlRelatedCard,
  SdlCta,
} from '../../components/stages-devops-lifecycle/index';
import { getPageMetadata } from '~/common/meta';
import FeaturesTemplate from '~/components/features/templates/features-template.vue';

export default Vue.extend({
  components: {
    SdlCta,
    SdlRelatedCard,
    Copy,
    CopyMedia,
    FeaturedMedia,
    CallToAction,
    FeaturesTemplate,
  },
  nuxtI18n: false,
  async asyncData({ $content, params, error }: any) {
    const doc = await $content(
      `stages-devops-lifecycle/${params.slug ? params.slug : 'index'}`,
    )
      .fetch()
      .catch((err) => error({ statusCode: 404, message: err }));
    return { doc };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).doc, this.$route.path);
  },
});
</script>

<template>
  <features-template v-if="doc.template === 'feature'" :page="doc" />
  <SlpContainer v-else>
    <component
      :is="component.name"
      v-for="component in doc.components"
      :key="component.name"
      :data="component.data"
    />
  </SlpContainer>
</template>
